ZOJ 2750 Idiomatic Phrases Game

Idiomatic Phrases Game

Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the list starts and ends with the two given idioms. For every two adjacent idioms, the last Chinese character of the former idiom should be the same as the first character of the latter one. For each time, Tom has a dictionary that he must pick idioms from and each idiom in the dictionary has a value indicates how long Tom will take to find the next proper idiom in the final list. Now you are asked to write a program to compute the shortest time Tom will take by giving you the idiom dictionary.

Input

The input consists of several test cases. Each test case contains an idiom dictionary. The dictionary is started by an integer N (0 < N < 1000) in one line. The following is N lines. Each line contains an integer T (the time Tom will take to work out) and an idiom. One idiom consists of several Chinese characters (at least 3) and one Chinese character consists of four hex digit (i.e., 0 to 9 and A to F). Note that the first and last idioms in the dictionary are the source and target idioms in the game. The input ends up with a case that N = 0. Do not process this case.

Output

One line for each case. Output an integer indicating the shortest time Tome will take. If the list can not be built, please output -1.

Sample Input

5

5 12345978ABCD2341

5 23415608ACBD3412

7 34125678AEFD4123

15 23415673ACC34123

4 41235673FBCD2156

2

20 12345678ABCD

30 DCBF5432167D

0

Sample Output

17

-1

#include<stdio.h>
#include<string.h>
#define INF 0x3fffffff
#define maxn 1000
struct idiom
{
	char front[5],back[5];
	int T;
};
idiom dic[maxn];
int edge[maxn][maxn];
int dist[maxn];
int S[maxn];
int N;
int main()
{
	int i,j,k;
	char s[100];
	int len;
	while(scanf("%d",&N)!=EOF,N)
	{
		for(k=0;k<N;k++)
		{
			scanf("%d%s",&dic[k].T,s);
			len=strlen(s);
			for(i=0,j=len-1;i<4;i++,j--)
			{
				dic[k].front[i]=s[i];
				dic[k].back[3-i]=s[j];
			}
			dic[k].front[4]=dic[k].back[4]=‘\0‘;
		}
		for(i=0;i<N;i++)
		{
			for(j=0;j<N;j++)
			{
				edge[i][j]=INF;
				if(i==j)continue;
				if(strcmp(dic[i].back,dic[j].front)==0)
					edge[i][j]=dic[i].T;
			}
		}
		for(i=0;i<N;i++)
		{
			dist[i]=edge[0][i];S[i]=0;
		}
		S[0]=1;dist[0]=0;
		for(i=0;i<N-1;i++)
		{
			int min=INF,u=0;
			for(j=0;j<N;j++)
			{
				if(!S[j]&&dist[j]<min)
				{
					u=j;min=dist[j];
				}
			}
			S[u]=1;
			for(k=0;k<N;k++)
			{
				if(!S[k]&&edge[u][k]<INF&&dist[u]+edge[u][k]<dist[k])
					dist[k]=dist[u]+edge[u][k];
			}
		}
		if(dist[N-1]==INF)printf("-1\n");
		else printf("%d\n",dist[N-1]);
	}
	return 0;
}

  

时间: 2024-11-08 14:17:37

ZOJ 2750 Idiomatic Phrases Game的相关文章

ZOJ 2750 -- Idiomatic Phrases Game(Dijkstra)

 ZOJ 2750 -- Idiomatic Phrases Game(Dijkstra) 题意 : 给定一本字典,字典里有很多成语,要求从字典里的第一个成语开始,运用字典里的成语变到最后一个成语,变得过程就是成语接龙,后一个成语的第一个字必须有前一个成语的最后一个字相等,给定的成语是4位16进制位,每个成语前边跟的数字代表着找到这个成语之后再找到下个成语还需要t分钟 . 思路 : 将所有的成语看成一个点,如果找到下一个成语,就建一条有向边,然后用dijkstra求最短路. 1 #include

zoj 1750 Idiomatic Phrases Game (dijkstra)

Idiomatic Phrases Game Time Limit: 2 Seconds      Memory Limit: 65536 KB Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should bui

Idiomatic Phrases Game(图论最短路)

Idiomatic Phrases Game Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3504    Accepted Submission(s): 1182 Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom cons

Idiomatic Phrases Game HDU 1546

Description Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the list starts and ends with the two

HDU 1546 Idiomatic Phrases Game

成语接龙. 上一个的尾必须和下一个的首相同.注意:花费的时间是上一个. 一开始我就建图建错了. 比如第 i 个成语 与第 j 个成语, 第  i 个成语前面的时间为 t : 建图为 i -> j = t: 基友说这<图论算法理论.实现及应用>上有一样的题,我借来看了一下,发现它建图似乎有错误. 0->3 这条边的权值似乎错了. 反正我的建图是这样的 0->1=5;0->3=5; 1->2=5; 2->4=7; 3->4=15; 求 0 -> 4

hdu1546——Idiomatic Phrases Game

Idiomatic Phrases Game Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 2191    Accepted Submission(s): 712 Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom cons

hdu 1546 Idiomatic Phrases Game 最短路

Idiomatic Phrases Game Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 2283    Accepted Submission(s): 742 Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom cons

Idiomatic Phrases Game 成语接龙SPFA+map

Idiomatic Phrases Game Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the list starts and ends w

HDU 1546 Idiomatic Phrases Game(dijkstra+优先队列)

Idiomatic Phrases Game Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the li